/* nag_info_impl_details (a00aac) Example Program.
 *
 * NLL6I27DB/NLL6I27DBL Version.
 *
 * Copyright 2019 Numerical Algorithms Group.
 *
 * Mark 27.0, 2019.
 */

#include <nag.h>
#include <stdio.h>
#include <string.h>

int main(void)
{
    Integer exit_status = 0;
    unsigned int sizeofpointer = sizeof(void *);
    unsigned int sizeofInteger = sizeof(Integer);
    unsigned int sp, si;

    /* Get the expected sizes of pointers and integers (in bytes) */
    a00aay(&sp, &si);

    printf("nag_info_impl_details (a00aac) Example Program Results\n\n");

    /* Check that the pointer and integer sizes are as expected, and
     issue a warning if not */
    if (sp != sizeofpointer || si != sizeofInteger) {
        printf("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
               "~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n");
        if (sp != sizeofpointer)
            printf(" Incorrect value of sizeof(void *)\n"
                   "  expected %u, returned %u.\n\n", sp, sizeofpointer);
        if (si != sizeofInteger)
            printf(" Incorrect value of sizeof(Integer)\n"
                   "  expected %u, returned %u.\n\n", si, sizeofInteger);
        printf(" The NAG Library header files are "
               "incompatible with the NAG Library.\n\n");
        printf(" Please check the location of your "
               "NAG Library include files.\n\n");
        printf("~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~"
               "~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n\n");
        exit_status = 1;
    }

    nag_info_impl_details();

    printf("nag_info_licence (a00acc) Example Program Results\n\n");

    if (!nag_info_licence()) {
        printf(" Unable to obtain a licence for this implementation.\n");
        exit_status = 1;
    }
    else {
        printf(" Licence query was successful\n");
    }

    return exit_status;
}
